
#version 3.8;

global_settings {assumed_gamma 1}
box {0,1}

#ifndef (global.I)
  #declare I = 0;
#end

// low resolution.
#declare R = <20,20,20>;

// I = {0,3,5} has 'slack'.
#switch (I)
  #case (0)
    #debug concat("cylinder","\n")
    #declare O = cylinder {
      0, 1, .25
      translate 5
    };
  #break
  #case (1)
    #debug concat("box","\n")
    #declare O = box {0, 1};
  #break
  #case (2)
    #debug concat("sphere","\n")
    #declare O = sphere {0, 1};
  #break
  #case (3)
    #debug concat("blob","\n")
    #declare O = blob {
      threshold .6
      sphere {0, 1, 1}
      scale 2
    };
    #declare R = <25,25,25>;
  #break
  #case (4)
    #debug concat("superellipsoid","\n")
    #declare O = superellipsoid {
      <.5,3.5>
      translate 5
    };
  #break
  #case (5)
    #debug concat("superellipsoid rotated","\n")
    #declare O = superellipsoid {
      <.5,3.5>
      rotate 45
      translate 5
    };
    #declare R = <25,25,25>;
  #break
  #else
    #error concat("oops, no object for I=",str(I,0,0),".\n")
#end

/*  -------------------------------------------------------------------------*/

#include "bounder.inc"

#macro Rebounder(obj_)
  #if (!(defined(Bounder_min_diff) & defined(Bounder_max_diff)))
    #error "oops, no 'Bounder_{min,max}_diff' variables."
  #end
  #local lb_ = min_extent(obj_) + Bounder_min_diff;
  #local ub_ = max_extent(obj_) - Bounder_max_diff;
  object {obj_ clipped_by {box {lb_,ub_}} bounded_by {clipped_by}}
#end

Bounder(O,R)

#ifdef (Bounder_min_diff)
  #declare O = Rebounder(O);
  Bounder(O,R)
#end

